from os import urandom
from hashlib import scrypt


class PasswordHasher:
    @staticmethod
    def hash(password):
        salt = urandom(32)
        return PasswordHasher.scrypt(password, salt).hex()+salt.hex()

    @staticmethod
    def verify(password, salted_hash):
        salt = bytes.fromhex(salted_hash)[32:]
        hashdigest = bytes.fromhex(salted_hash)[:32]
        return PasswordHasher.scrypt(password, salt) == hashdigest

    @staticmethod
    def scrypt(password, salt):
        return scrypt(password.encode(), salt=salt, n=16384, r=8, p=1, dklen=32)
